unit TCK;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TFKategoria = class(TForm)
    GroupBox1: TGroupBox;
    LBSlownictwo: TListBox;
    GroupBox2: TGroupBox;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    SpeedButton2: TSpeedButton;
    ENewSlowo: TEdit;
    SBNew: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton7: TSpeedButton;
    BitBtn1: TBitBtn;
    procedure SBNewClick(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure ENewSlowoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ENewSlowoChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function CutExt(S: String): String;
  end;

var
  FKategoria: TFKategoria;

implementation

uses TCUnit1;

{$R *.DFM}

function TFKategoria.CutExt(S: String): String;
 var
  X: Byte;
begin
   X := (Length(S)-4);
   Result := Copy(S,0,X);
end;

procedure TFKategoria.SBNewClick(Sender: TObject);
begin
 if(Length(Trim(ENewSlowo.Text))<2)or(Length(Trim(ENewSlowo.Text))>12)then
  begin
   ShowMessage('Za dugo sowa (powinno zawiera 2-12 znakw)'); exit;
  end;
 LBSlownictwo.Items.Add(Trim(AnsiUpperCase(ENewSlowo.Text)));
 ENewSlowo.Text:='';
end;

procedure TFKategoria.SpeedButton4Click(Sender: TObject);
begin
 If OpenDialog.Execute then
  begin
   LBSlownictwo.Clear;
   LBSlownictwo.Items.LoadFromFile(OpenDialog.FileName);
   FKategoria.Caption := 'Kategoria "' + AnsiUpperCase((ExtractFileName(CutExt(OpenDialog.FileName)) +'"'));
   FormTC.PiszInfo(AnsiUpperCase(CutExt(ExtractFileName(OpenDialog.FileName))));
   FormTC.NowaGra;
  end;
end;

procedure TFKategoria.SpeedButton5Click(Sender: TObject);
 var
  x: word;
begin
 if Application.MessageBox('Skasowa wybrane sowo !','Potwierd',MB_ICONQUESTION or MB_YESNO ) = IDYes  then
 if LBSlownictwo.SelCount <= 0 then exit;
  try
   for x := (LBSlownictwo.Items.Count - 1) downto 0 do if LBSlownictwo.Selected[x] then LBSlownictwo.Items.Delete(x);
   except
  end;
end;

procedure TFKategoria.SpeedButton3Click(Sender: TObject);
begin
 SaveDialog.FileName := FormTC.LKategoria.Caption;
 If SaveDialog.Execute then
  begin
   LBSlownictwo.Items.SaveToFile(SaveDialog.FileName);
   FKategoria.Caption := 'Kategoria "' + (CutExt(ExtractFileName(SaveDialog.FileName)) +'"');
   FormTC.PiszInfo(AnsiUpperCase(CutExt(ExtractFileName(SaveDialog.FileName))));  end;
   FKategoria.Caption := 'Kategoria "' + AnsiUpperCase((CutExt(ExtractFileName(SaveDialog.FileName)) +'"'));
end;

procedure TFKategoria.SpeedButton2Click(Sender: TObject);
 var
  strValue: String;
begin
 if InputQuery('Nowa Kategoria','Podaj nazw nowej kategorii ',strValue) then
  begin
   LBSlownictwo.Clear;
   FormTC.PiszInfo(AnsiUpperCase(strValue));
   FKategoria.Caption := 'Kategoria "' + (AnsiUpperCase(strValue))+'"';
  end;
end;

procedure TFKategoria.ENewSlowoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key <> VK_RETURN then exit;
 if(Length(Trim(ENewSlowo.Text))<2)or(Length(Trim(ENewSlowo.Text))>12)then
  begin
   ShowMessage('Za dugo sowa (powinno zawiera 2-12 znakw)'); exit;
  end;
 LBSlownictwo.Items.Add(Trim(AnsiUpperCase(ENewSlowo.Text)));
 ENewSlowo.Text:='';
end;

procedure TFKategoria.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 FormTC.NowaGra;
end;

procedure TFKategoria.ENewSlowoChange(Sender: TObject);
begin
 SBNew.Enabled := Length(Trim(ENewSlowo.Text))>1;
end;

end.
