unit TCUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TFormTC = class(TForm)
    Image1: TImage;
    I1: TImage;
    I2: TImage;
    I3: TImage;
    I4: TImage;
    I5: TImage;
    I6: TImage;
    I7: TImage;
    I8: TImage;
    I9: TImage;
    I10: TImage;
    I11: TImage;
    IWin: TImage;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    GroupBox1: TGroupBox;
    SBQuery1: TSpeedButton;
    SBQuery7: TSpeedButton;
    SBQuery3: TSpeedButton;
    SBQuery2: TSpeedButton;
    SBQuery6: TSpeedButton;
    SBQuery5: TSpeedButton;
    SBQuery4: TSpeedButton;
    SBQuery8: TSpeedButton;
    SBQuery9: TSpeedButton;
    SBQuery10: TSpeedButton;
    SBQuery11: TSpeedButton;
    SBQuery12: TSpeedButton;
    GroupBox2: TGroupBox;
    SpB1: TSpeedButton;
    SpB3: TSpeedButton;
    SpB4: TSpeedButton;
    SpB6: TSpeedButton;
    SpB7: TSpeedButton;
    SpB10: TSpeedButton;
    SpB11: TSpeedButton;
    SpB12: TSpeedButton;
    SpB13: TSpeedButton;
    SpB15: TSpeedButton;
    SpB17: TSpeedButton;
    SpB14: TSpeedButton;
    SpB18: TSpeedButton;
    SpB20: TSpeedButton;
    SpB21: TSpeedButton;
    SpB23: TSpeedButton;
    SpB24: TSpeedButton;
    SpB26: TSpeedButton;
    SpB27: TSpeedButton;
    SpB28: TSpeedButton;
    SpB29: TSpeedButton;
    SpB30: TSpeedButton;
    SpB31: TSpeedButton;
    SpB32: TSpeedButton;
    SpB9: TSpeedButton;
    SpB22: TSpeedButton;
    SpB2: TSpeedButton;
    SpB8: TSpeedButton;
    SpB5: TSpeedButton;
    SpB33: TSpeedButton;
    SpB34: TSpeedButton;
    SpB16: TSpeedButton;
    SpB19: TSpeedButton;
    SpB35: TSpeedButton;
    SpB25: TSpeedButton;
    StatusBar: TStatusBar;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    GBKategoria: TGroupBox;
    SpeedButton4: TSpeedButton;
    LKategoria: TStaticText;
    procedure SpB1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure StatusBarDblClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ZlaOdpowiedz;
    procedure CzyscObraz;
    procedure CzyscPrzyciskiSBQuery;
    procedure SetVisibleBQuery;
    procedure ClearDownSPB;
    function DobraLitera(SBLitera: TSpeedButton): Boolean;
    function Wygrales: Boolean;
    procedure NowaGra;
    procedure PiszInfo(S: String);

  end;

var
  FormTC: TFormTC;
  Haslo: String;
  Crack: Boolean;

implementation

uses TCK;

{$R *.DFM}

function Losuj(Num :Byte) :Byte;
begin
 Randomize;
 Result:= Random(Num);
end;

function ShowElements :String;
var
 x :Integer;
begin
 x := Losuj(FKategoria.LBSlownictwo.Items.Count);
 Result := FKategoria.LBSlownictwo.Items.Strings[x];
end;

procedure TFormTC.CzyscObraz;
 var
  x: byte;
  I: TImage;
begin
 for x := 11 downto 1 do
  begin
   I := TImage(FindComponent('I'+IntToStr(x)));
   I.Visible := False;
  end;
 IWin.Visible := False;
end;

procedure TFormTC.NowaGra;
begin
 if FKategoria.LBSlownictwo.Items.Count = 0 then
  begin
   ShowMessage('Brak sownictwa! Kliknij "Kategoria" w celu wczytania zestawu sownictwa !');exit;
  end;
 CzyscPrzyciskiSBQuery;
 ClearDownSpB;
 CzyscObraz;
 Haslo := ShowElements;
 SetVisibleBQuery;
 StatusBar.SimpleText := 'Wybierz liter !'
end;

procedure TFormTC.CzyscPrzyciskiSBQuery;
 var
  x: byte;
  B: TSpeedButton;
begin
 for x := 1 to 12 do
  begin
   B := TSpeedButton(FindComponent('SBQuery'+IntToStr(x)));
   B.Caption := '_';
  end;
end;

procedure TFormTC.ClearDownSpB;
 var
  x: byte;
  B: TSpeedButton;
begin
 for x := 1 to 35 do
  begin
   B := TSpeedButton(FindComponent('SpB'+IntToStr(x)));
   B.AllowAllUp := True;
   B.Down := False;
   B.AllowAllUp := False;
   B.Font.Color := clBlack;
  end;
end;

function TFormTC.Wygrales: Boolean;
 var
  x,y: byte;
  B: TSpeedButton;
begin
  y := 0;
  for x := 1 to Length(Haslo) do
   begin
    B := TSpeedButton(FindComponent('SBQuery'+IntToStr(x)));
    if B.Caption <> '_' then Inc(y);
   end;
 if y = Length(Haslo) then Result := True else Result := False;
end;

procedure TFormTC.ZlaOdpowiedz;
 var
  x: byte;
  I: TImage;
  s: String;
begin
 for x := 1 to 10 do
  begin
   I := TImage(FindComponent('I'+IntToStr(x)));
   if I.Visible=False then
    begin
     I.Visible := True;
     exit;
    end;
  end;
 I11.Visible := True;
 StatusBar.SimpleText := 'Przykro mi ...';
 s := 'Szukane Haso to '+PChar(AnsiUpperCase(Haslo))+' !   Chcesz sprbowa jeszcze raz ?';
 if MessageDlgPos(s,mtConfirmation, mbYesNoCancel,
    0, FormTC.Left, FormTC.Top) = MrNo then Close else NowaGra;
end;

function TFormTC.DobraLitera(SBLitera: TSpeedButton): Boolean;
 var
  x: byte;
  B: TSpeedButton;
begin
  Result := False;
  for x := 1 to Length(Haslo) do
   begin
    if SBLitera.Caption = UpperCase(Copy(Haslo,x,1)) then
     begin
      B := TSpeedButton(FindComponent('SBQuery'+IntToStr(x)));
      B.Caption := SBLitera.Caption;
      StatusBar.SimpleText := 'Wskazana litera wystpuje w HALE !';
      Result := True;
     end;
   end;
end;

procedure TFormTC.SpB1Click(Sender: TObject);
 var
  BCurent: TSpeedButton;
begin
 if FKategoria.LBSlownictwo.Items.Count = 0 then
  begin
   ShowMessage('Brak sownictwa! Kliknij "Kategoria" w celu wczytania zestawu sownictwa !');exit;
  end;
 BCurent := (sender as TSpeedButton);
 if BCurent.Font.Color=clGray then exit;
 BCurent.Font.Color := clGray;
 if not(DobraLitera(BCurent)) then
  begin
   StatusBar.SimpleText := 'Wskazana litera NIE wystpuje w HALE !';
   ZlaOdpowiedz;
  end;
 if Wygrales then
  begin
   StatusBar.SimpleText := 'Prawidowe HASO !';
   IWin.Visible := True;
   if MessageDlgPos('Gratuluje  !!!   Grasz jeszcze raz ?',mtConfirmation, mbYesNoCancel,
    0, FormTC.Left + 3, FormTC.Top + 30) = MrNo then Close else NowaGra;
  end;
end;

procedure TFormTC.SpeedButton1Click(Sender: TObject);
begin
 if Application.MessageBox('Na pewno chcesz zacz now gr ?','Potwierd',
   MB_ICONQUESTION or MB_YESNO ) = IDYes  then NowaGra;
end;

procedure TFormTC.SetVisibleBQuery;
 var
  x: byte;
  B: TSpeedButton;
begin
 for x := 2 to Length(Haslo) do
  begin
   B := TSpeedButton(FindComponent('SBQuery'+IntToStr(x)));
   B.Visible := True;
  end;
 if Length(Haslo) <  12 then
  for x := Length(Haslo)+1 to 12 do
   begin
    B := TSpeedButton(FindComponent('SBQuery'+IntToStr(x)));
    B.Visible := False;
   end;
end;

procedure TFormTC.StatusBarDblClick(Sender: TObject);
 var
  y: String;
begin
 if Crack=False then if InputQuery('Crack','Podaj haso',y) then  if y <> 'typ' then exit;
 ShowMessage(Haslo);
 Crack := True;
end;

procedure TFormTC.SpeedButton2Click(Sender: TObject);
begin
 if Application.MessageBox('Na pewno chcesz wyj ?','Potwierd',
    MB_ICONQUESTION or MB_YESNO ) = IDYes  then Application.Terminate;
end;

procedure TFormTC.SpeedButton3Click(Sender: TObject);
begin
 ShowMessage('(c) Krzysztof Wojakowski, Bielsko-Biaa, 22-11-1998');
end;

procedure TFormTC.SpeedButton4Click(Sender: TObject);
begin
 FKategoria.ShowModal;
end;

procedure TFormTC.PiszInfo(S: String);
begin
 LKategoria.Caption := S;
 LKategoria.Left := GBKategoria.Width div 2 - LKategoria.Width div 2;
end;

end.
